
; TITLE      : HACKSTOP - CRC CHECK - CRACKER
; VERSION    : 1.0
; AUTHOR     : Christoph Gabler
; DATE       : 12.08.99 (code), 13.08.99 (comments)
; PROG TYPE  : Simple patcher
; WORKS WITH : HS 1.17, 1.18, 1.19 (*UNPACKED ONLY*)
; USED MUSIC : Megadeth[Cryptic Writings] for code, Pantera[Cowboys from hell]


; ADDITIONAL INFORMATION :
; Not much optimized code, 386+ because of dword usage. Anyway lame.
; Public Domain.

Code Segment
Org  100h
Assume Cs:Code, Ds:Code
.386

CHRiSTOPH:

; Nonstandard way to get two lines further
Ror DS:byte ptr [@@1], 1
Mov Ah, 9
Call $+6
db 0Dh,0Ah, '$'
Pop Dx
Int 21h
Cmp Dh, -1
@@1 db 0EAh, 0ECh
Ret

; Display ' HACKSTOP '
Mov DS:byte ptr [Persil_Color], 1Ch    ; This is the used color
Mov Di, offset Message2                ; Offset to message
Displ_Loop2:
Call Displ                             ; Routine used for displaying
Cmp DS:byte ptr [DI], 0
Je $+4
Jmp Displ_Loop2                        ; Loop the whole


; Display '- CRC CHECK '
Mov DS:byte ptr [Persil_Color], 1Fh
Mov Di, offset Message3
Displ_Loop3:
Call Displ
Cmp DS:byte ptr [DI], 0
Je $+4
Jmp Displ_Loop3

; Display '- CRACKER '
Mov DS:byte ptr [Persil_Color], 1Eh
Mov Di, offset Message4
Displ_Loop4:
Call Displ
Cmp DS:byte ptr [DI], 0
Je $+4
Jmp Displ_Loop4

Call Next_Line                         ; Display next line

; Display 'Coded by Christoph Gabler'
Mov DS:byte ptr [Persil_Color], 19h
Mov Di, offset Message5
Displ_Loop5:
Call Displ
Cmp DS:byte ptr [DI], 0
Je $+4
Jmp Displ_Loop5

Call Next_Line                         ; Display next line
Call Next_Line                         ; Display next line

; Get entered filename
Xor Ax, Ax
Mov Cx, Ax
Mov Cl, Ds:byte ptr [80h]              ; Lenght of cmd line
Mov Di, 81h
Add Di, Cx
Cwd                                    ; Set direction for stosb
Stosb                                  ; ES:DI = AL (0Dh=00)

Mov Ax, 3D02h                          ; Open file for read/write
Mov Dx, 0082h                          ; Point to cmd line
Int 21h
Jc No_Input                            ; If CF set then no input file/not f.
Mov DS:word ptr [Handle], Ax           ; Save handle for later

Xor Cx, Cx
Xor Dx, Dx
Mov Bx, DS:word ptr [Handle]           ; BX=Handle
Mov Ax, 4202h                          ; Set filepointer to end of file
Int 21h       
Mov DS:word ptr [FileSize], Ax         ; Save filesize for latah
                                       ; AX=Filesize till 65 KB
                                       ; DX=Filesize more than 65 KB
Xor Cx, Cx
Xor Dx, Dx
Mov Bx, DS:word ptr [Handle]
Mov Ax, 4200h                          ; Set filepointer to begin
int 21h

Mov Cx, DS:word ptr [FileSize]         ; CX=Ammount of bytes
Mov Bx, DS:word ptr [Handle]           ; BX=Handle
Mov Dx, Offset EOF                     ; DX=Where to put the bytes
Mov Ah, 3Fh                            ; Read the whole lame file into mem
Int 21h

Mov Ah, 3Eh                            ; Close file now
Mov Bx, DS:word ptr [Handle]           ; BX=Handle
Int 21h

Call Next_Line                         ; Guess

; Display 'Varifying file...'
Mov DS:byte ptr [Persil_Color], 1Fh
Mov Di, offset MsgSearch1
Displ_L0:
Call Displ
Cmp DS:byte ptr [DI], 0
Je $+4
Jmp Displ_L0

; Do the HS internal signature search
Mov Cx, DS:word ptr [FileSize]         ; Ammount of bytes to search tru
Inc Cx                                 ; Corrects zero byte bug
Mov Si, Offset EOF                     ; Point to red-in data
Search1:
Cmp DS:dword ptr [SI], ' :KO'          ; (OK: )HS 1
Je HS_Sig                              ; If sig found jump
@@Back:
Inc Si                                 ; Point one byte further
Loop Search1                           ; Loop the whole

; Display 'No HS sig found'
Mov DS:byte ptr [Persil_Color], 1Ch
Mov Di, offset MsgNoHS
Displ_L1:
Call Displ
Cmp DS:byte ptr [DI], 0
Je $+4
Jmp Displ_L1
Jmp MainSearch

HS_Sig:
Cmp DS:dword ptr [SI+4], '1 SH'        ; OK: (HS 1)
Jne @@Back                             ; If not the sig jump back

; Display 'HS sig found'
Mov DS:byte ptr [Persil_Color], 1Ch
Mov Di, offset MsgHS
Displ_L2:
Call Displ
Cmp DS:byte ptr [DI], 0
Je $+4
Jmp Displ_L2

MainSearch:
Call Next_Line

; Display 'Seeking for crc check...'
Mov DS:byte ptr [Persil_Color], 1Fh
Mov Di, offset MsgSearch2
Displ_L3:
Call Displ
Cmp DS:byte ptr [DI], 0
Je $+4
Jmp Displ_L3

Mov Cx, DS:word ptr [FileSize]         ;
Inc Cx                                 ; -> See above
Mov Si, Offset EOF                     ;
Search2:
Cmp DS:word ptr [SI], 3E81h            ; 81h, 3Eh (CMP DS:WORD PTR [xxxx], ??)
Je Patch1
@@Back2:
Inc Si
Loop Search2

Cmp Bp, 1234h                          ; If not BP=1234 then bytes not found
Jne Nothing_found

; Display 'success'
Mov DS:byte ptr [Persil_Color], 1Ch
Mov Di, offset MsgSuccess
Displ_L5:
Call Displ
Cmp DS:byte ptr [DI], 0
Je $+4
Jmp Displ_L5

Call Next_Line

; Display 'writing to disk'
Mov DS:byte ptr [Persil_Color], 1Fh
Mov Di, offset MsgWrite
Displ_L6:
Call Displ
Cmp DS:byte ptr [DI], 0
Je $+4
Jmp Displ_L6

; Display 'Done!'
Mov DS:byte ptr [Persil_Color], 1Ah
Mov Di, offset MsgDone
Displ_Lx7:
Call Displ
Cmp DS:byte ptr [DI], 0
Je $+4
Jmp Displ_Lx7

Mov Ah, 3Ch                            ; Create file using handle
Xor Cx, Cx                             ; CX=File attributes
Mov Dx, Offset NewFile                 ; DX=Offset to filename
Int 21h
Mov Si, Ax                             ; Save handle in SI

Mov Ah, 40h                            ; Write file
Mov Dx, Offset EOF                     ; DX=From where to write
Mov Cx, DS:word ptr [FileSize]         ; CX=Ammount of bytes to write
Mov Bx, Si                             ; BX=Handle
Int 21h

Mov Ah, 3Eh                            ; Close file
Mov Bx, Si                             ; BX=Handle
Int 21h

Jmp Ending                             ; Lame end message

Nothing_found:

; Display 'nothing found'
Mov DS:byte ptr [Persil_Color], 1Ch
Mov Di, offset MsgNoSucc
Displ_L4:
Call Displ
Cmp DS:byte ptr [DI], 0
Je $+4
Jmp Displ_L4

Call Next_Line

; Display 'writing to disk'
Mov DS:byte ptr [Persil_Color], 1Fh
Mov Di, offset MsgWrite
Displ_Lx6:
Call Displ
Cmp DS:byte ptr [DI], 0
Je $+4
Jmp Displ_Lx6

; Display 'not done!'
Mov DS:byte ptr [Persil_Color], 1Ch
Mov Di, offset MsgDone2
Displ_L7:
Call Displ
Cmp DS:byte ptr [DI], 0
Je $+4
Jmp Displ_L7

Jmp Ending                             ; Lame end message

Patch1: 
Cmp DS:word ptr [SI+6], 0D74h  ; JNE xxxx (last min. removed: 0CAh,01h check)
Jne @@Back2                    ; If not known byte comp. then go back

Mov DS:byte ptr [SI+6], 0EBh   ; Apply patch in memory
Mov Bp, 1234h                  ; Signal the success of patching
Jmp @@Back2

Ending:
Call Next_Line
Call Next_Line

; Display 'Done by CHRiSTOPH for the public on 12.08.99!'
Mov DS:byte ptr [Persil_Color], 1Ch
Mov Di, offset Message1
Displ_L9:
Call Displ
Cmp DS:byte ptr [DI], 0
Je $+4
Jmp Displ_L9

Call Next_Line
ExitDOS:
Call Next_Line

Mov Ax, 4C00h                  ; Exit to DOS (not windows! ;)
Int 21h

No_Input:

; Display 'Blah, blah, blah...'
Mov Dx, offset Message6
Mov Ah, 9
Int 21h

Jmp ExitDOS


; Messages

Message1 db '       Done by CHRiSTOPH for the public on 12.08.99!      ', 0
Message2 db ' HACKSTOP ',0                                             ;
Message3 db '- CRC CHECK ',0
Message4 db '- CRACKER ',0
Message5 db ' Coded by Christoph Gabler      ',0
Message6 db 'This program is able to remove HackStop''s internal crc check',0Dh,0Ah
         db 'so that unpacked and modified versions of HS86.EXE and HS386.EXE',0Dh,0Ah
         db 'don''t display "HackStop: Bad CRC/Hacked" and crash if you try to',0Dh,0Ah
         db 'encrypt a file. Now you are able to register HS yourself.',0Dh,0Ah,0Dh,0Ah
         db 'Error: Please specify an unpacked HS executable (HS386.EXE or HS86.EXE)',0Dh,0Ah,'$'
MsgSearch1 db ' Varifying file... ',0
MsgSearch2 db ' Seeking for crc check... ',0

MsgNoHS    db 'HS internal signature not found       ',0
MsgHS      db 'HS internal signature found           ',0
MsgSuccess db 'Successfully found and patched ',0
MsgNoSucc  db 'Neccassary bytes were not found',0
MsgWrite   db ' Writing to disk... ', 0
MsgDone    db 'Done! PATCHED.EXE was created.       ', 0
MsgDone2   db 'Not done!                            ', 0
                                 

; Additional data

Persil_Color db 0
Handle db 0,0
FileSize db 0,0
Korfu99 db 'Korfu ''99 ruled!'  ; yeah, whatever
NewFile db 'PATCHED.EXE',0


; Routine for displaying
Displ:
Xor Bh, Bh
Mov Al, DS:byte ptr [DI]
Inc Di
Mov Bl, DS:byte ptr [Persil_Color]
Mov Cx, 1
Mov Ah, 9
Int 10h

Mov Ah, 3                      ; Get current cursor position
Xor Bx, Bx                     ; BX=Display mode
Int 10h                     
                               ; DX=Cursor location, CX=Mode
Inc Dl                         ; Move the cursor one pos further right
Mov Ah, 2                      ; Set cursor
Int 10h                        ; DX=Cursor location, CX=Mode
Ret                            ; Return from caller

; One line further routine including color display fix
Next_Line:
Mov DS:byte ptr [Persil_Color], 7
Mov Cx, 60h
BullShit:
Mov Di, offset Korfu99
Push Cx
Call Displ
Pop Cx
Loop BullShit

Mov Ah, 9
Call $+6
db 0Dh,0Ah, '$'
Pop Dx
Int 21h
Ret

EOF:

Code ends
End CHRiSTOPH
